{***************************************************************************}
{ TMS GuiMotions Demo                                                       }
{ for Delphi & C++Builder                                                   }
{                                                                           }
{ written by TMS Software                                                   }
{            copyright  2008                                               }
{            Email : info@tmssoftware.com                                   }
{            Web : http://www.tmssoftware.com                               }
{                                                                           }
{ The source code is given as is. The author is not responsible             }
{ for any possible damage done due to the use of this code.                 }
{ The component can be freely used in any application. The complete         }
{ source code remains property of the author and may not be distributed,    }
{ published, given or sold in any form as such. No parts of the source      }
{ code can be included in any other component or application without        }
{ written authorization of the author.                                      }
{***************************************************************************}

{
	- AdvStringGrid must be installed to run demo (http://www.tmssoftware.com/site/advgrid2.asp)
	- d3dx9_33.dll must be present in the \Windows\System32 folder
}

unit GUImotionsC;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GUIMotions, StdCtrls, Math, ComCtrls, GUIMotions3D, Grids,
  BaseGrid, AdvGrid, DateUtils, ExtCtrls;

type
  TForm42 = class(TForm)
    GUIMotions1: TGUIMotions;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure GUIMotions1ImageCustomDraw(Sender: TObject; Image: Integer;
      Picture: TBitmap);
    procedure GUIMotions1ImageSelected(Sender: TObject; Image: Integer;
      ImageRectangle: TRect);
    procedure GUIMotions1ImageZoomed(Sender: TObject; Image: Integer;
      ImageRectangle: TRect);
    procedure GUIMotions1ImageUnZoom(Sender: TObject; Image: Integer;
      ImageRectangle: TRect);
    procedure GUIMotions1ImageChanged(Sender: TObject; PreviousImage,
      CurrentImage: Integer; device: IDirect3DDevice9);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form42: TForm42;

implementation

{$R *.dfm}

procedure TForm42.FormCreate(Sender: TObject);
var
  I, J, K: Integer;
  c: TAdvStringGrid;
  colors: array[0..20] of TColor;

begin
  colors[0] := clBlue;
  colors[1] := clRed;
  colors[2] := clGreen;
  colors[3] := clAqua;
  colors[4] := clMaroon;
  colors[5] := clOlive;

  for I := 1 to 12 do
  begin
    with GUIMotions1.Images.Add do
    begin
      c := TAdvStringGrid.Create(GUIMotions1);
      c.Visible := false;
      c.RowCount := 100;
      c.ColCount := 20;
      c.RandomFill(false,100);
      c.Options := c.Options + [goEditing];
      c.FixedFont.Style := [fsBold];
      c.AutoNumberCol(0);
      for j := 0 to c.ColCount - 1 do
        c.Cells[j,0] := 'Column ' + inttostr(j);
      c.Bands.Active := true;

      Control := c;
      c.Parent := GUIMotions1;
      Caption := LongMonthNames[i]
    end;
  end;
end;

procedure TForm42.GUIMotions1ImageChanged(Sender: TObject; PreviousImage,
  CurrentImage: Integer; device: IDirect3DDevice9);
begin
  GUIMotions1.Images[GUIMotions1.GetCurrentSelectedImage].Update;
  TAdvStringGrid(GUIMotions1.Images[PreviousImage].Control).visible := false;
end;

procedure TForm42.GUIMotions1ImageCustomDraw(Sender: TObject; Image: Integer;
  Picture: TBitmap);
var
  c: TAdvStringGrid;
begin
  c := TAdvStringGrid(GUIMotions1.Images[Image].Control);

  c.Width := GUIMotions1.PictureWidthZoomed;
  c.Height := GUIMotions1.PictureHeightZoomed;

  picture.Width := GUIMotions1.PictureWidthZoomed;
  picture.Height := GUIMotions1.PictureHeightZoomed;
  
  c.PaintTo(Picture.Canvas, 0, 0);
end;

procedure TForm42.GUIMotions1ImageSelected(Sender: TObject; Image: Integer;
  ImageRectangle: TRect);
var
  r: TRect;
  i: integer;
begin
  for I := 0 to GUIMotions1.Images.Count - 1 do
  begin
    with GUIMotions1.Images[I] do
    begin
      Control.Visible := false;
    end;
  end;
end;

procedure TForm42.GUIMotions1ImageUnZoom(Sender: TObject; Image: Integer;
  ImageRectangle: TRect);
begin
  GUIMotions1.Images[GUIMotions1.GetCurrentSelectedImage].Update;
  TAdvStringGrid(GUIMotions1.Images[Image].Control).visible := false;
end;

procedure TForm42.GUIMotions1ImageZoomed(Sender: TObject; Image: Integer;
  ImageRectangle: TRect);
var
  r: TRect;
begin
  r := ImageRectangle;
  TAdvStringGrid(GUIMotions1.Images[Image].Control).SetBounds(r.Left, r.Top, r.Right - r.Left, r.Bottom - r.Top);
  TAdvStringGrid(GUIMotions1.Images[Image].Control).visible := true;

end;

end.
